
Event do(
	docCategory("Networking")
    newSlot("descriptorId", -1)
    newSlot("eventType", nil)
    newSlot("timeout", 10)
    newSlot("coro", nil) // internal
    setSlot("EV_TIMER", 0)

    debugWriteln := nil
    debugOff := method(self debugWriteln := nil)
    debugOn := method(self debugWriteln := getSlot("writeln"))
    //debugOn
    
    eventTypeName := method(
        if(eventType == EV_READ,   return "EV_READ")
        if(eventType == EV_WRITE,  return "EV_WRITE")
        if(eventType == EV_SIGNAL, return "EV_SIGNAL")
        if(eventType == EV_TIMER,  return "EV_TIMER")
        "?"  
    )
    
    handleEvent := method(isTimeout,
        //writeln("-Event ", eventTypeName, " handleEvent(", isTimeout, ")")
        //debugWriteln(coro label, " resuming - got ", eventTypeName)
        self isTimeout := isTimeout
        if(coro,
            tmpCoro := coro
            setCoro(nil)
            tmpCoro resumeLater
            yield
        )
    )
    
    waitOn := method(t,
        if(t, timeout = t)

        if(coro, Exception raise("already waiting on this event"))
        coro = Scheduler currentCoroutine

        EventManager addEvent(self, descriptorId, eventType, timeout) ifFalse(coro = nil; return false)
        coro pause
        isTimeout == false
    )
    
    waitOnOrExcept := method(t,
        waitOn(t)
        isTimeout ifTrue(Exception raise("timeout"))
    )
)

ReadEvent := Event clone setEventType(Event EV_READ) do(
	docCategory("Networking")
)

WriteEvent  := Event clone setEventType(Event EV_WRITE) do(
	docCategory("Networking")
)

SignalEvent := Event clone setEventType(Event EV_SIGNAL) do(
	docCategory("Networking")
)

TimerEvent  := Event clone setEventType(Event EV_TIMER) do(
	docCategory("Networking")
)

Object wait := method(t, TimerEvent clone setTimeout(t) waitOn)

EventManager do(
	docCategory("Networking")
    
    realAddEvent := getSlot("addEvent")
    
    addEvent := method(e, descriptorId, eventType, timeout,
        r := self realAddEvent(e, descriptorId, eventType, timeout)
        if(self getLocalSlot("actorCoroutine"), self actorCoroutine resumeLater, self @@run)
        r
    )

    run := method(
    	actorCoroutine setLabel("EventManager")
                
        while(hasActiveEvents,
            if(Coroutine yieldingCoros first, listen, listenUntilEvent)
            yield
        )
    )
)

EventManager setListenTimeout(0.03)
