// Socket; Core setupMaster


Core := Object clone do(
    connections := List clone
    newSlot("id")
    
    startServerOnPort := method(port,
        self doServer := DOServer clone setRootObject(self) setPort(port) 
        doServer coroDo(start)
        yield
    )
    
    outfile := method(
        self outfile := File with("output") openForAppending
    )
    
    outfile write("start\n")
    
    setupMaster := method(
        setId(0)
        startServerOnPort(8000)

        for(i, 0, System activeCpus,
            writeln("starting thread on core ", i)
            s := "Socket; Core setupChild(" .. i .. ", " .. doServer port ..")"
            //System createThread(s)
            SystemCall clone asyncRun("io", list("-e", s), Map clone)
        )
        pause
    )
    
    /*
    writeln := method(
        for(i, 0, call arguments, 
            outfile write(call evalArgAt(i))
        )
        resend
    )
    */

    setupChild := method(id, parentPort,
        outfile write(id .. " setupChild(" .. id .. ", " .. parentPort .. ")\n")
        outfile flush
        setId(id)
        startServerOnPort(parentPort + id)        
        connectToPort(parentPort)
        writeln("setupChild done")
        pause
    )

    connections := List clone
    
    isMaster := method(id == 0)
    
    connectToPort := method(port,
        outfile write(id .. " connectToPort(" .. port .. ")\n")
        writeln(id, " connectToPort(", port, ")")
        
        connections detect(port == port) ifNil(
            con := DOConnection clone setHost("127.0.0.1") setPort(port) connect
            if(isMaster, connections foreach(serverObject connectToPort(port)))
            connections append(con)
            //con serverObject connectToPort(doServer port)
            writeln(id, " connections size = ", connections size)
        )
        self
    )
)
    
Random numberStringOfSize := method(size,
    s := Sequence clone
    size repeat(s appendSeq(Random value(0, 9) floor asString))
    s
)
