Point := Vector clone setSize(2) 
Color := Vector clone setSize(4)

Box copy := method(box,
    self origin copy(box origin)
    self size copy(box size)
)

Sequence asVector := method(Vector clone copy(self))

vector := method(
	v := Vector clone setSize(0)
	call message arguments foreach(i, arg, 
		v atPut(i, call sender doMessage(arg))
	)
	v
)

Vector append := method(v,
    n := self size
    self setSize(n+1)
    self atPut(n, v)
)

Vector derivative := method(
    last := self at(0)
    for(i, 1, self size - 1,
        v := self at(i)
        self atPut(i - 1, v - last)
        last = v
    )
    self
)

Vector average := method(p,
    last := self at(0)
    for(i, 1, self size - 1,
        v := self at(i)
        self atPut(i - 1, (v + last) / 2)
        last = v
    )
    self
)

List asVector := method(
        v := Vector clone setSize(0)
        self foreach(d, v append(d))
        v
)

Vector do(
	asString := method(self serialized asString)
	
	serialized := method(b, 
		if(b == nil, b := Sequence clone)
		b appendSeq("vector(")
		if(size > 0,
			for (i, 0, size - 1,
				if(i > 0, b appendSeq(", "))
				b appendSeq(self at(i) asString)
			)
		)
		b appendSeq(")")
	)

	asSimpleString := method(
		result := Sequence clone appendSeq("vector(")
		if(size > 0,
			values := result
			for(i, 0, size - 1,
				if(i > 0, values appendSeq(", "))
				values appendSeq(self at(i) asString)
				if(values == result and values size > 30,
					values := Sequence clone
				)
			)
			if(values != result,
				if(values size <= 10,
					result appendSeq(values)
				,
					result appendSeq(", ...")
				)
			)
		)
		result appendSeq(")")
	)

	print := method(self serialized print)
)

Box do(
	asString := method(self serialized asString)
	
	serialized := method(b, 
		if(b == nil, b := Sequence clone)
		b appendSeq("Box clone do(")
		b appendSeq("setOrigin(")
		origin serialized(b)
		b appendSeq("); ")
		b appendSeq("setSize(")
		size serialized(b)
		b appendSeq("));")
	)

	print := method(self serialized print)
)

Vector