/*  Copyright (c) 2004, Kentaro A. Kurahone
 *  All rights reserved.
 */

#include "base/Common.h"
#include "IoObject.h"

#ifndef _IO_ARRAY_H_
#define _IO_ARRAY_H_

typedef IoObject IoArray;
typedef struct
{
  long d;
  long elems;
  long *size;
  long *idxCache;
  IoObject **backingStore;
} IoArrayData;

IoArray* IoArray_proto(void *state);
IoArray* IoArray_new(void *state);
IoArray* IoArray_rawClone(IoArray *self);
void IoArray_free(IoArray *self);
void IoArray_mark(IoArray *self);

IoArray* IoArray_sizeTo_(IoArray *self, IoObject *locals, IoMessage *m);
IoObject* IoArray_at(IoArray *self, IoObject *locals, IoMessage *m);
IoObject* IoArray_atPut_(IoArray *self, IoObject *locals, IoMessage *m);

#endif
