/*  Copyright (c) 2004, Steve Dekorte
 *  All rights reserved.
 */

#include "base/Common.h"
#include "IoObject.h"
#include "base/Vector.h"

#ifndef IOVECTOR
#define IOVECTOR

typedef IoObject IoVector;

#define ISVECTOR(self) IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoVector_rawClone)

IoVector *IoVector_proto(void *state);
IoVector *IoVector_new(void *state);
IoVector *IoVector_rawClone(IoVector *self);

void IoVector_free(IoVector *self);
void IoVector_mark(IoVector *self);

Vector *IoVector_rawVector(IoVector *self);

IoObject *IoVector_copy_(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_subarray(IoVector *self, IoObject *locals, IoMessage *m);

IoObject *IoVector_setSize_(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_size(IoVector *self, IoObject *locals, IoMessage *m);

IoObject *IoVector_at_(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_at_put_(IoVector *self, IoObject *locals, IoMessage *m);

/* --- math -------------------------------------------- */
IoObject *IoVector_add(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_subtract(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_multiply(IoVector *self, IoObject *locals, IoMessage *m);

IoObject *IoVector_sum(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_min(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_max(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_mean(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_square(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_normalize(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_absolute(IoVector *self, IoObject *locals, IoMessage *m);

IoObject *IoVector_log(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_log10(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_pow(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_random(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_sort(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_reverseSort(IoVector *self, IoObject *locals, IoMessage *m);



IoObject *IoVector_meanSquare(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_rootMeanSquare(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_dotProduct(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_sin(IoVector *self, IoObject *locals, IoMessage *m);

IoObject *IoVector_setMin_(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_setMax_(IoVector *self, IoObject *locals, IoMessage *m);
IoObject *IoVector_set_(IoVector *self, IoObject *locals, IoMessage *m);

#endif
