Future := Object clone do(
	type := "Future"
    newSlot("runTarget", nil)
    newSlot("runMessage", nil)
    newSlot("waitingCoros", nil)
    newSlot("hasTrigger", false)
    
    futureProxy := method(
    	self waitingCoros := List clone
    	self proxy := Object clone
    	proxy _future := self
    	proxy forward := method(
			//writeln("proxy forwarding: ", call message )
    		//call delegateTo(_future getSlot("result"))
			_future result doMessage(call message, call sender)
    	)
    	proxy removeAllProtos
    	proxy
    )
        
    setResult := method(r,
		if(waitingCoros, waitingCoros foreach(resumeLater))
		self result := getSlot("r")
    )
    
    result := method(
  		waitingCoros append(Scheduler currentCoroutine)
    	Scheduler currentCoroutine pause
		self getSlot("result")
    )
)

Object do(
	yield := method(Coroutine currentCoroutine yield)
	pause := method(Coroutine currentCoroutine pause)
	//actorCoroutine := method(self actorCoroutine := self coroDo(yield; actorProcessQueue))
	
	actorRun := method(
		if(self hasLocalSlot("actorCoroutine"),
        	if(actorQueue size == 0, self actorCoroutine resumeLater)
		,
			self actorQueue := List clone
			// need to yield in coroDo to allow future to be added to queue
        	self actorCoroutine := self coroDoLater(yield; actorProcessQueue)
       	    self actorCoroutine run
        )
	)
 
 	actorProcessQueue := method(
        //writeln(self type, "_", self uniqueId, " actorProcessQueue")
        
		if(Coroutine currentCoroutine isIdenticalTo(self actorCoroutine) not, 
			writeln("actorProcessQueue called from coro ", Coroutine currentCoroutine uniqueId, " instead of ", actorCoroutine uniqueId)
			System exit
		)
            		
		loop(
			while(future := actorQueue removeFirst,			    
				e := try(
				    future setResult(self doMessage(future runMessage))
				)
				
				if(e, handleActorException(e))
				yield
			)

		  if(Coroutine currentCoroutine isIdenticalTo(self actorCoroutine) not, 
			writeln("actorProcessQueue1 called from coro ", Coroutine currentCoroutine uniqueId, " instead of ", self actorCoroutine uniqueId)
			System exit
            )
			self actorCoroutine pause
        )
	)
	
	handleActorException := method(e, e showStack)
	
	setSlot("@", method(
	    //writeln("@ ", call argAt(0))
        m := call argAt(0) asMessageWithEvaluatedArgs(call sender)
        f := Future clone setRunTarget(self) setRunMessage(m)
		self actorRun
        self actorQueue append(f)
        f futureProxy
	))
 
	setSlot("@@", method(
	    //writeln(self type , "_", self uniqueId, " @@", call argAt(0)) //, " ", call argAt(0) label)
        m := call argAt(0) asMessageWithEvaluatedArgs(call sender)
        f := Future clone setRunTarget(self) setRunMessage(m) 
		self actorRun
        self actorQueue append(f)
        nil
	))
)

