Number do(
	docSlot("isInASequenceSet", "Return true if receiver is in one of the Sequence sequenceSets, otherwise false.")
	isInASequenceSet := method(
		Sequence sequenceSets foreach(set,
			if(in(set), return true)
		)
		false
	)
	
  constants := Object clone do(
    docSlot("constants pi", "Returns the constant pi.")
    pi := 3.14159265358979323846264338327950288

    docSlot("constants nan", "Returns a infinity constant.")    
    nan := method(Number constants nan := (0/0))

    docSlot("constants inf", "Returns a not-a-number constant.")    
    inf := method(Number constants inf := (1/0))
        
    docSlot("constants e", "Returns the constant e.")
    e  := 2.71828182845904523536028747135266249
  )

  asSimpleString := method(self asString)

	docSlot("nextInSequence(skipVal)", "Returns the next item in the sequence counting away from zero. The optional skipVal parameter allows you to skip the number specified and get that value (the next value after self + skipVal).")
	nextInSequence := method(skipVal,
		if(skipVal isNil, skipVal = 1)
		self + skipVal
	)

  docSlot("to", "Convenience constructor that returns a cursor object representing the range of numbers from the receiver to the 'endingPoint' parameter. Increments over each item in that range by 1.")
  to := method(e, self toBy(e, 1))

  docSlot("toBy(endingPoint, incrementValue)", "Convenience constructor that returns a cursor object representing the range of numbers from the receiver to the 'endingPoint' parameter. Increments over each item in that range by the 'incrementValue' parameter.")
  toBy := method(e, i,
    if(i < 0, Exception raise("increment value must be non-negative"))
		if((e - self) < i, e = self)
		if(self > e, i = 0 - i)
    Range clone setRange(self, e, i)
  )
)
