@echo off
::
:: This uses IoVM.vcproj to generate IoVM-replaced_files.vcproj
::
:: This uses the prefix of IoVM.vcproj and replaces all lines from
:: "<File>" to "</File>".
::  - This will not work properly if there is useful data on the same
::    line as <File> or </File> since the entire line is removed.
::  - Luckily, MSVS always seems to put them on their own line.
::  - Blank lines are also removed.
::  - Use the python script if there's a problem.
::
:: -- Kevin Edwards
:: 2005-12-25 : created
::

:: allows us to set variables in the for loop
SetLocal EnableDelayedExpansion

set fileIn=IoVM.vcproj
set fileOut=IoVM-replaced_files.vcproj

echo %fileOut% is being generated.

type nul >%fileOut%

:: go through the file and output the prefix lines
set LINE=
set LINEX=
for /F "delims=" %%A in (%fileIn%) do (
  set LINE=%%A
  set LINEX=!LINE:^<Files^>=!
  if not !LINEX!==!LINE! goto :prefix_done
  echo.!LINE!>>%fileOut%
)

:prefix_done
::echo.>>%fileOut%
call _iovm_vcproj_files.cmd >>%fileOut%
::echo.>>%fileOut%

:: go through the file again and output the postfix lines
set LINE=
set LINEX=
set DO_OUTPUT=false
for /F "delims=" %%A in (%fileIn%) do (
  set LINE=%%A
  set LINEX=!LINE:^</Files^>=!
  if !DO_OUTPUT!==true echo.!LINE!>>%fileOut%
  if not !LINEX!==!LINE! set DO_OUTPUT=true
)

:: echo.^<Globals^>^</Globals^>^</VisualStudioProject^>>>%fileOut%

:end

EndLocal

